On March 7 of this year, my overwhelmingly popular Minecraft mod Actually Additions [celebrated its fifth birthday](https://www.curseforge.com/minecraft/mc-mods/actually-additions/files/2229705). I personally made my last real contribution to the project [around mid-June 2017](https://github.com/Ellpeck/ActuallyAdditions/commits/main?after=896a082d747a3e19755ded1973544d59fa992787+244), so basically three years ago. Every now and again, though (and by that, I mean almost constantly), I still get asked about the project. The main question I get is: "Will you port Actually Additions to Minecraft 1.15?"

Here's the short answer: No, I won't. I haven't worked on the project in *three years*. But this post isn't about that. It's about why *you* probably shouldn't port it either.

I've grown a lot in the last five years. Yes, I've literally grown in the last five years - I'm 20 years old now. But I've also grown as a programmer, and more importantly, as a game designer. In this post, I'm going to reminisce about some features of Actually Additions, tell you why I added them, how I added them and what I'd do differently if I made the mod today. Since I can't be bothered opening a modpack instance, I'm just going to go off of the information from the [online manual](https://www.ellpeck.de/actaddmanual/) for this list.

# "Actually Additions"
When first starting out with the mod, it was called something like "Some Pretty Techy Stuff". I realized that was a *terrible* name choice though, so I changed it to "Some Pretty *Random* Stuff" pretty quickly. That wasn't much better, so after some (evidently not very much) consideration, I apparently settled on *the worst possible mod name*, "Actually Additions". It makes no grammatical sense unless you add a comma, and it's annoying to say for me because, as any non-native English speaker knows, saying "Actually" is very hard.

# Overpowered Items
A lot of items in Actually Additions suffer the exact same problem: They're *balanced because they take effort*. What that means is that they're overpowered beyond belief, because they usually take a somewhat large amount of resources to create (though that isn't even true for some of them) and then do something crazy at (basically) no cost. All of these items are ones I'd either implement completely differently today, or scrap entirely:
- The Fishing Net
- Greenhouse Glass
- The Item Repairer
- The Ring of Growth

## Oh God, Storage Crates
Why do people love them so much? They make every other mod's storage options *completely worthless*. Why they're not disabled in more modpacks is a complete mystery to me.

I don't think there's any code I've written in my life that I regret as much as Storage Crates. God, they're awful.

## Solar Panels
When I first implemented them, I thought passive power generation was perfectly fine. That opinion changed pretty quickly the more I got used to working with RF-based mods and the struggle of trying to balance them against each other. So... I changed solar panels to be ridiculously expensive and only generate 8 RF per tick, which is a rather small amount.

Still, a lot of people kept on using them. *Creative*.

If you really, *really* want to port Actually Additions to 1.15, at least remove all of these unbalanced features first. Or at least try to make them less horrible somehow.

# Phantomfaces
I still, to this day, *adore* the way I implemented Phantomfaces. They look good, they work well, they have unique functionality, but... **everyone uses them wrong**. They're not supposed to be a means of item transportation. How could I make them be more restricted to their intended use case? I don't really know, honestly.

# The Coffee Maker
Etho is my favorite YouTuber of all time, and always has been. When he first used the Coffee Maker in his HermitCraft modded series, I legitimately cried of happiness. Following that point, he made and used it in every modded series that it was available in. 

I still think it's a great block with awesomely unique functionality, and I have been considering implementing something similar in functionality into my newer mod Nature's Aura.

# Canola and Oil
There's not much to say about the entire canola power generation system other than... I love it. I think it's a great way to generate power in almost every modpack. It's easy to set up, it scales well to higher tiers of power generation and it's a fun thing to automate. It makes me happy to see that a lot of people seem to still agree nowadays.

# Wings of the Bats
I'm not the *biggest* fan of creative flight in survival mode anymore in general, but I do like how I implemented the Wings of the Bats. For those of you who don't know: They have a charge that runs out when you fly with them. If you land on the ground, the charge slowly fills back up again. *But* if you fly up to the ceiling and hover there for a while, the charge fills up a lot faster than if you were to stand on the ground. Because you're a bat.

# AIOTS
...were a huge mistake. "All-In-One-Tools", originally called something ridiculous like "Paxelordoe" (Pickaxe, Shovel, Sword and Hoe), were pretty much intended to be a better version of Mekanism's paxels. I like the idea of all-in-one tools in general, but I think they should be later game. I also think they should *not* have **eight times** the durability of the tools they were made from.

# Laser Relays
Laser Relays were my sorry attempt at copying Immersive Engineering's awesome wires. Did I succeed in that? No. But did I still make something hella awesome? Yes. As with all of the other things on this list that I actually do like, they scale well and they look good.

I personally especially love the item laser relays, because they can do almost as much as logistics pipes can, minus the request terminal. Do people that use them realize that? Most of the time, no. Is there a way to fix that? Probably, but I don't know what it is.

# The Atomic Reconstructor
...is awesome, plain and simple. This is one of the features I added surprisingly late in development, probably a year or so after the mod originally came out, if I had to guess. The reason I like it so much is that I'm a huge fan of in-world crafting. It's less boring than sitting in front of some UI-heavy machine, and it's more fun to automate too. If I made Actually Additions again today, the Atomic Reconstructor would still be the mod's centerpiece. Also, the lenses are cool.

The crystals, though... I don't think I'd want them to work the same nowadays. The names were ridiculous, the textures were weird and the materials used to make them were generic and boring. Actually, I originally picked the ridiculous anagram-ish names specifically because I *knew* YouTubers would have trouble saying them, and the thought of that was hilarious to me.

# Lush Caves
They don't fit the mod (because it's not a biome/world gen mod), so most modpacks disable them. I don't really understand why, though, because they add so much to the world! 

This game desperately needs a cave update.

# The Textures
The textures for Actually Additions were created by three separate artists, as well as *me*, the latter of which is very far from an artist.

That's why the visual style of the mod is inconsistent and honestly pretty gross. The textures of blocks don't fit together, most of them are flat and uninspired. The mod doesn't use that many nice particles and other visual effects to enhance the look and feel of mechanics.

Altogether, when playing the mod now, the texture and overall visual style of the mod make me feel like I'm playing some bizarre combination of old ruins, a tech mod and a confused magic mod.

# Honorable-ish Mentions 
**Black Quartz**. Why didn't I make it drop the item directly instead of the ore? I don't know. Weird choice, though.

**Smiley Clouds**. God, they're creepy. Yes, they were just supposed to be a clone of Botania's Tiny Potato. Were they as well designed? No. Were they as cool? No. Would I ever want them in my life ever again? Definitely not.

**Treasure Chests**. I like the feature, but... does anyone even know they exist?

**ESDs** were actually one of the first features in the mod. I still like them, though their UI is clunky and hard to understand. If I made Actually Additions today, I'd definitely include them, but with a different name and a cleaner UI.

**Experience Solidifiers** are great. I like the solidified experience too, though I know that a lot of modpack makers seem to disagree, as it's disabled in almost every pack. I'd still want them today, though.

**The Feeder** is an almost exact copy of the Railcraft Feeding Station thing, because back in the day, I was so unoriginal that I just stole other people's content. Yea.

**Drills**. Love 'em. The upgrade system is neat and scales well, they use a good amount of power and they just look *so cool*.

**Balls of Fur** are actually called "hairy balls." I don't know if the fact that I *didn't* realize that that wasn't the best name when implementing them makes this whole situation less embarrassing or more embarrassing.

**The Empowerer** is still pretty cool in my opinion. I'd probably use it as a crafting mechanic again.

# What Do We Learn From This?
Well, I don't know if you learn anything from this, but there's one thing I learned for sure: I'm a lot better of a programmer and a lot better of a game designer now.

Sure, I'd still consider Actually Additions to be a pretty good mod, and it's definitely a nice project to be known for. But I don't think I'd do almost anything in the mod the same way nowadays. 

Also, I kind of think that Actually Additions has run its course in some way; it's lived its life. It's important to remember that there is a huge amount of new, unexplored mod ideas still out there, and that there are already some great mods that implement unique, new ideas. Shouldn't we let those mods step into the spotlight now?