const projects = [{
        name: 'Actually Additions',
        desc: 'Actually Additions is a rather popular Minecraft mod that I used to work on. It\'s become widely known in the modding community and has reached over 30 million downloads by now, which is crazy. I don\'t work on it anymore myself, but it\'s being maintained for current versions by someone else.',
        links: {
            'CurseForge page': 'https://www.ellpeck.de/actadd',
            "Report an issue": "https://github.com/Ellpeck/ActuallyAdditions/issues",
            'Online manual': 'https://www.ellpeck.de/actaddmanual/'
        },
        status: 'Maintained',
        icon: 'aa'
    },
    {
        name: "Nature's Aura",
        desc: "Nature's Aura is a Minecraft mod about collecting, using and replenishing the Aura naturally present in the world to create useful devices and unique mechanics.",
        status: 'In development',
        links: {
            'CurseForge page': 'https://minecraft.curseforge.com/projects/natures-aura',
            "Report an issue": "https://github.com/Ellpeck/NaturesAura/issues"
        },
        icon: 'na'
    },
    {
        name: "Pretty Pipes",
        desc: "Pretty Pipes is a simple to use, all-inclusive item transport mod for Minecraft. It features simple pipes that can be upgraded using modules to accomplish much more advanced tasks.",
        status: 'In development',
        links: {
            'CurseForge page': 'https://www.curseforge.com/minecraft/mc-mods/pretty-pipes',
            "Report an issue": "https://github.com/Ellpeck/PrettyPipes/issues"
        },
        icon: 'pp'
    },
    {
        name: "Tiny Life",
        desc: "Tiny Life is a fun simulation game that tries to capture the essence of games like The Sims, but in an isometric pixelart style. It's currently in development, but you can already play it and even make your own mods!",
        status: "In development",
        links: {
            "Check it out": "https://ellpeck.itch.io/tiny-life"
        },
        icon: "tiny"
    },
    {
        name: "MLEM",
        desc: "MLEM Library for Extending MonoGame is an addition to the game framework <a href=\"http://www.monogame.net/\">MonoGame</a> that provides extension methods, quality of life improvements and additional features like a Ui system and easy input handling.",
        links: {
            "Get it on NuGet": "https://www.nuget.org/packages?q=mlem",
            "See the website": "https://mlem.ellpeck.de/"
        },
        status: "Side project",
        icon: "mlem"
    },
    {
        name: 'Touchy Tickets',
        desc: "Touchy Tickets is a fun idle game for Android that has you selling tickets with various theme park attractions.",
        links: {
            'Google Play': "https://play.google.com/store/apps/details?id=de.ellpeck.touchytickets"
        },
        status: "Released",
        icon: 'tt'
    }
];

let p = '';
for (let project of projects) {
    let links = "";
    if (project.links) {
        for (let name in project.links)
            links += /*html*/ `<a href="${project.links[name]}" class="card-link btn ${dark ? "btn-outline-light" : "btn-outline-info"} rounded-0">${name}</a>`;
    }

    p += /*html*/ `
        <div class="card bg-light project rounded-0">
            <div class="card-body">
                <img class="project-image" src="res/projects/${project.icon}.png" alt="">
                <h4 class="card-title">${project.name}</h4>
                <p class="card-text">${project.desc}</p>
                ${project.status ? /*html*/ `<span class="text-muted project-status">${project.status}</span>` : ""}
                ${links}
            </div>
        </div>
    `;
}
$('#project-list').html(p);